<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
	<title> pcb-rnd - help wanted </title>
	<meta http-equiv="Content-Type" content="text/html;charset=us-ascii">
<!--AUTO head begin-->
	<link rel="icon" href="resources/logo16.png">
<!--AUTO head end-->
</head>
<body>

<!--AUTO navbar begin-->
<table border=0 cellspacing=2 cellpadding=10  bgcolor="#eeeeee" width="100%">
<tr>
<th align=center bgcolor="#ccc0cc"> <a href="index.html"> Main </a>
<th align=center bgcolor="#ccc0cc"> <a href="news.html"> News </a>
<th align=center bgcolor="#ccc0cc"> <a href="doc.html">Doc</a>&nbsp;&amp;&nbsp;<a href="http://repo.hu/projects/pcb-rnd-aux/pool">pool</a>
<th align=center bgcolor="#ccc0cc"> <a href="support.html"> Support </a>
<th align=center bgcolor="#ccc0cc"> <a href="http://repo.hu/cgi-bin/pcb-rnd-people.cgi">People</a>
<th align=center bgcolor="#ccc0cc"> <a href="http://repo.hu/cgi-bin/pcb-rnd-people.cgi?cmd=events">Events</a>&nbsp;&amp;&nbsp;<a href="http://www.repo.hu/cgi-bin/pcb-rnd-people.cgi?cmd=timeline">timeline</a>
<td align=right width="60%"> <font size="+2"><i>pcb-rnd</i></font> <img src="resources/logo32.png" alt="[pcb-rnd logo]">
</table>
<!--AUTO navbar end-->

<h1> pcb-rnd - help wanted - details </h1>

<h2 id="rosetta"> porting example scripts </h2>
<p>
The rosetta scripts start with an awk script, because awk is my favorite 
language. When the awk version is tested out and the documentation 
finalized, the script needs to be ported to different languages. The 
porting is line-by-line, becuase we want to have all scripts do the same 
and look the same, that's how it's easy to compare them.
<p>
If you have a favorite language, you could join porting example scripts to 
that language.
<p>
Requirements: knowing your scripting language, system-wide fungw 
installation, pcb-rnd from svn.

<h2 id="fungw_pkg"> packaging fungw for your favorite distro </h2>
<p>
At the moment fungw has no packaging coverage. Because we use fungw as the 
action infrastructure, we have a minimal (no-script) version embedded in 
src_3rd/ and scconfig already has the logics for choosing a system 
installed version over the local version when avaialble.
<p>
To make system installs more wide-spread, we need OS packages, preferrably 
official packages in as many systems as possible. Fungw is small: the core 
lib and all existing engines (~ script language bindings) take up 4k sloc 
total). The only challange is that we need to have a modular packaging: a 
core package and one package per script language binding, to avoid the 
core package depending on 6..8 scripting engines.
<p>
Requirements: knowing your favorite distro's packaging model


<h2 id="script_pkg"> packaging libmawk, funlisp, estutter </h2>
<p>
These three scripting language libs are relatively small (funlisp is even 
tiny), and unlike many popular languages they come with a nice, generic 
API. Unfortunately they are not widely known so we lack OS packages. They 
are generally easy to package.
<p>
Requirements: knowing your favorite distro's packaging model

<h2 id="actionw"> action wrapper programming </h2>
<p>
Most of our API in pcb-rnd are good, old-fashioned, raw C APIs. Which 
means they are currently unaccessible to scripts. To make them accessible, 
we need to write action wrappers. Such an action wrapper is usually 
simple, as 90% of the time we want to expose the very same API, 
parameter-to-parameter, in a coordinated effort.
<p>
Requirements: intermediate C knowledge, willing to learn the fungw API, 
willing to use svn and IRC
</body>
</html>
